package dev.fitko.fitconnect.client.cmd.commands;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import dev.fitko.fitconnect.client.cmd.util.AttachmentDataType;
import dev.fitko.fitconnect.client.cmd.util.UUIDConverter;
import dev.fitko.fitconnect.client.cmd.util.UUIDValidator;

import java.util.Collections;
import java.util.List;
import java.util.UUID;

import static dev.fitko.fitconnect.client.cmd.commands.SendSubmissionCommand.SEND_CMD_NAME;

@Parameters(
        commandNames = {SEND_CMD_NAME},
        commandDescription = "Send a submission",
        separators = "="
)
public class SendSubmissionCommand {

    public static final String SEND_CMD_NAME = "send";

    @Parameter(names = { "--destinationId" }, converter = UUIDConverter.class, description = "Unique destination identifier in UUID format", validateWith = UUIDValidator.class, arity = 1, required = true)
    public
    UUID destinationId;

    @Parameter(names = { "--serviceName"}, arity = 1, description = "Name of the service type", required = true)
    public
    String serviceName;

    @Parameter(names = { "--leikaKey"}, arity = 1, description = "The LeikaKey of the service type", required = true)
    public
    String leikaKey;

    @Parameter(names = { "--data"}, arity = 1,  description = "Path to JSON or XML data", required = true)
    public
    String data;

    @Parameter(names = { "--dataType"}, arity = 1, description = "Data mime type (JSON/XML), default JSON", required = true)
    public
    AttachmentDataType dataType = AttachmentDataType.JSON;

    @Parameter(names = "--attachments", description = "Attachments as list of paths", variableArity = true)
    public
    List<String> attachments = Collections.emptyList();

}

